background_image_filename = 'yuuno-background.jpg'
mouse_image_filename = 'yuuno.png'

import pygame
from pygame.locals import *
from sys import exit

pygame.init()

screen_size = (800, 524)
screen = pygame.display.set_mode(screen_size, 0, 32)
pygame.display.set_caption("Hello, Yuuno!")

background = pygame.image.load(background_image_filename).convert()
cursor = pygame.image.load(mouse_image_filename).convert_alpha()

cursor_x = (screen_size[0] - cursor.get_width()) / 2
cursor_y = (screen_size[1] - cursor.get_height()) / 2

hold = {K_LEFT: False, K_RIGHT: False, K_UP: False, K_DOWN: False}

while True:
    for event in pygame.event.get():
        if event.type == QUIT:
            exit()
        if event.type == KEYDOWN:
           if event.key in [K_LEFT, K_RIGHT, K_UP, K_DOWN]:
               hold[event.key] = True               
        if event.type == KEYUP:
            if event.key in [K_LEFT, K_RIGHT, K_UP, K_DOWN]:
                hold[event.key] = False
            
    dx, dy = 0, 0    
    if hold[K_LEFT]:
        dx = -1
    if hold[K_RIGHT]:
        dx = 1
    if hold[K_UP]:
        dy = -1
    if hold[K_DOWN]:
        dy = 1
        
    cursor_x += dx
    cursor_y += dy
        
    if cursor_x < 0:
        cursor_x = 0
    if cursor_x > screen_size[0]-cursor.get_width():
        cursor_x = screen_size[0]-cursor.get_width()
    if cursor_y < 0:
        cursor_y = 0
    if cursor_y > screen_size[1]-cursor.get_height():
        cursor_y = screen_size[1]-cursor.get_height()    
    
    screen.blit(background, (0,0))    
    screen.blit(cursor, (cursor_x, cursor_y))
    
    pygame.display.update()