background_image_filename = 'background.jpg'
mouse_image_filename = 'miyako.png'

import pygame
from pygame.locals import *
from sys import exit

pygame.init()

screen_size = (800, 566)
screen = pygame.display.set_mode(screen_size, 0, 32)
pygame.display.set_caption("Hello, Miyako!")

background = pygame.image.load(background_image_filename).convert()
cartoon = pygame.image.load(mouse_image_filename).convert_alpha()

cartoon_x = (screen_size[0] - cartoon.get_width()) / 2
cartoon_y = (screen_size[1] - cartoon.get_height()) / 2
start_cartoon_x = 0
start_cartoon_y = 0
start_x = 0
start_y = 0

drag = False

def inside(left, top, width, height, x, y):
    return (left <= x and x < left + width and
            top <= y and y < top + height)

while True:
    for event in pygame.event.get():
        if event.type == QUIT:
            exit()
            
        if event.type == MOUSEBUTTONDOWN:
            if event.button == 1:
                if inside(cartoon_x, cartoon_y, 
                          cartoon.get_width(), cartoon.get_height(),
                          event.pos[0], event.pos[1]):
                    x = event.pos[0] - cartoon_x
                    y = event.pos[1] - cartoon_y
                    color = cartoon.get_at((x,y))                    
                    if color[3] > 0:
                        start_x = event.pos[0]
                        start_y = event.pos[1]
                        start_cartoon_x = cartoon_x
                        start_cartoon_y = cartoon_y
                        drag = True
                        
        if event.type == MOUSEBUTTONUP:
            if event.button == 1:
                drag = False
                
        if event.type == MOUSEMOTION:
            if drag:
                cartoon_x = start_cartoon_x + event.pos[0] - start_x
                cartoon_y = start_cartoon_y + event.pos[1] - start_y
                        
    if cartoon_x < 0:
        cartoon_x = 0
    if cartoon_x > screen_size[0]-cartoon.get_width():
        cartoon_x = screen_size[0]-cartoon.get_width()
    if cartoon_y < 0:
        cartoon_y = 0
    if cartoon_y > screen_size[1]-cartoon.get_height():
        cartoon_y = screen_size[1]-cartoon.get_height()    
    
    screen.blit(background, (0,0))    
    screen.blit(cartoon, (cartoon_x, cartoon_y))
    
    pygame.display.update()