"""
Contains the class GameOver mode.
"""

from menu_mode import *
import pygame
import sys

class GameOverMode(MenuMode):
    """
    A mode that displays the "Game Over" message
    and allows the user to choose between
    (1) playing the game again, (2) returning
    to the title screen, and (3) quitting the game.
    """
    def __init__(self, engine):
        MenuMode.__init__(self, engine, "GAME OVER", ["play again", "return to title", "quit"], 
                          engine.vera64, engine.vera32)
        
        self.grey_surface = pygame.Surface(self.engine.screen.get_size(),
                                           0, 32)
        self.grey_surface.fill((0,0,0))
        self.grey_surface.set_alpha(218)
    
    def render(self, surface):
        self.engine.play_mode.player_piece = None
        self.engine.play_mode.render(surface)
        surface.blit(self.grey_surface, (0,0))
        
        self.render_menu(surface)
        
    def choice_selected(self, choice_index):
        if choice_index == 0:
            self.engine.play_mode.new_board()
            self.engine.change_mode(self.engine.play_mode)
        elif choice_index == 1:
            self.engine.change_mode(self.engine.title_mode)
        else:
            sys.exit()