"""
Contain the class TitleMode.
"""

from menu_mode import *
import pygame
import sys

class TitleMode(MenuMode):
    """
    A mode that displays the title screen.
    """
    def __init__(self, engine):
        MenuMode.__init__(self, engine, "Tetris", ["start", "quit"], engine.vera64, engine.vera32)
        
    def choice_selected(self, choice_index):
        if choice_index == 0:
            self.engine.play_mode.new_board()
            self.engine.change_mode(self.engine.play_mode)
        elif choice_index == 1:
            sys.exit()
            
    def switched_into(self, from_mode):
        MenuMode.switched_into(self, from_mode)
        self.current_choice = 0
        
    def render(self, surface):
        surface.fill((0,0,0))
        self.render_menu(surface)